from django.core.management.base import BaseCommand

from arkindex.process.models import Repository


class Command(BaseCommand):
    help = "Update all Git repositories hooks"

    def add_arguments(self, parser):
        parser.add_argument(
            "base_url",
            type=str,
            help="Base url used to build the new hooks",
        )

    def handle(self, base_url, *args, **kwargs):
        for repository in Repository.objects.filter(credentials__isnull=False):
            self.stdout.write(f"Updating {repository}")
            repository.provider.create_hook(repository, base_url=base_url)

        self.stdout.write(self.style.SUCCESS("All done"))
