select min(length),
       max(length)
FROM
    (select array_length(p.path, 1) as length
     from documents_elementpath as p
     inner join
         (SELECT "documents_element"."id"
          FROM "documents_element"
          INNER JOIN "documents_classification" ON ("documents_element"."id" = "documents_classification"."element_id")
          WHERE "documents_classification"."id" IS NOT NULL) as input on (array[input.id] && p.path)) as lengths ;

DELETE
FROM "documents_transcriptionentity"
WHERE "documents_transcriptionentity"."id" IN
        (SELECT W0."id"
         FROM "documents_transcriptionentity" W0
         INNER JOIN "documents_transcription" W1 ON (W0."transcription_id" = W1."id")
         WHERE W1."element_id" IN
                 (SELECT V0."id"
                  FROM "documents_element" V0
                  INNER JOIN "documents_elementpath" V1 ON (V0."id" = V1."element_id")
                  WHERE V1."path"[2] IN
                          (SELECT U0."id"
                           FROM "documents_element" U0
                           INNER JOIN "documents_classification" U1 ON (U0."id" = U1."element_id")
                           WHERE U1."id" IS NOT NULL)));

DELETE
FROM "documents_transcription"
WHERE "documents_transcription"."element_id" IN
        (SELECT V0."id"
         FROM "documents_element" V0
         INNER JOIN "documents_elementpath" V1 ON (V0."id" = V1."element_id")
         WHERE V1."path"[2] IN
                 (SELECT U0."id"
                  FROM "documents_element" U0
                  INNER JOIN "documents_classification" U1 ON (U0."id" = U1."element_id")
                  WHERE U1."id" IS NOT NULL));

DELETE
FROM "process_workeractivity"
WHERE "process_workeractivity"."element_id" IN
        (SELECT V0."id"
         FROM "documents_element" V0
         INNER JOIN "documents_elementpath" V1 ON (V0."id" = V1."element_id")
         WHERE V1."path"[2] IN
                 (SELECT U0."id"
                  FROM "documents_element" U0
                  INNER JOIN "documents_classification" U1 ON (U0."id" = U1."element_id")
                  WHERE U1."id" IS NOT NULL));

DELETE
FROM "documents_metadata"
WHERE "documents_metadata"."element_id" IN
        (SELECT V0."id"
         FROM "documents_element" V0
         INNER JOIN "documents_elementpath" V1 ON (V0."id" = V1."element_id")
         WHERE V1."path"[2] IN
                 (SELECT U0."id"
                  FROM "documents_element" U0
                  INNER JOIN "documents_classification" U1 ON (U0."id" = U1."element_id")
                  WHERE U1."id" IS NOT NULL));

DELETE
FROM "documents_classification"
WHERE "documents_classification"."element_id" IN
        (SELECT V0."id"
         FROM "documents_element" V0
         INNER JOIN "documents_elementpath" V1 ON (V0."id" = V1."element_id")
         WHERE V1."path"[2] IN
                 (SELECT U0."id"
                  FROM "documents_element" U0
                  INNER JOIN "documents_classification" U1 ON (U0."id" = U1."element_id")
                  WHERE U1."id" IS NOT NULL));

DELETE
FROM "documents_selection"
WHERE "documents_selection"."element_id" IN
        (SELECT V0."id"
         FROM "documents_element" V0
         INNER JOIN "documents_elementpath" V1 ON (V0."id" = V1."element_id")
         WHERE V1."path"[2] IN
                 (SELECT U0."id"
                  FROM "documents_element" U0
                  INNER JOIN "documents_classification" U1 ON (U0."id" = U1."element_id")
                  WHERE U1."id" IS NOT NULL));

DELETE
FROM "process_processelement"
WHERE "process_processelement"."element_id" IN
        (SELECT V0."id"
         FROM "documents_element" V0
         INNER JOIN "documents_elementpath" V1 ON (V0."id" = V1."element_id")
         WHERE V1."path"[2] IN
                 (SELECT U0."id"
                  FROM "documents_element" U0
                  INNER JOIN "documents_classification" U1 ON (U0."id" = U1."element_id")
                  WHERE U1."id" IS NOT NULL));

UPDATE "process_process"
SET "element_id" = NULL
WHERE "process_process"."element_id" IN
        (SELECT V0."id"
         FROM "documents_element" V0
         INNER JOIN "documents_elementpath" V1 ON (V0."id" = V1."element_id")
         WHERE V1."path"[2] IN
                 (SELECT U0."id"
                  FROM "documents_element" U0
                  INNER JOIN "documents_classification" U1 ON (U0."id" = U1."element_id")
                  WHERE U1."id" IS NOT NULL));

UPDATE "process_process"
SET "train_folder_id" = NULL
WHERE "process_process"."train_folder_id" IN
        (SELECT V0."id"
         FROM "documents_element" V0
         INNER JOIN "documents_elementpath" V1 ON (V0."id" = V1."element_id")
         WHERE V1."path"[2] IN
                 (SELECT U0."id"
                  FROM "documents_element" U0
                  INNER JOIN "documents_classification" U1 ON (U0."id" = U1."element_id")
                  WHERE U1."id" IS NOT NULL));

UPDATE "process_process"
SET "validation_folder_id" = NULL
WHERE "process_process"."validation_folder_id" IN
        (SELECT V0."id"
         FROM "documents_element" V0
         INNER JOIN "documents_elementpath" V1 ON (V0."id" = V1."element_id")
         WHERE V1."path"[2] IN
                 (SELECT U0."id"
                  FROM "documents_element" U0
                  INNER JOIN "documents_classification" U1 ON (U0."id" = U1."element_id")
                  WHERE U1."id" IS NOT NULL));

UPDATE "process_process"
SET "test_folder_id" = NULL
WHERE "process_process"."test_folder_id" IN
        (SELECT V0."id"
         FROM "documents_element" V0
         INNER JOIN "documents_elementpath" V1 ON (V0."id" = V1."element_id")
         WHERE V1."path"[2] IN
                 (SELECT U0."id"
                  FROM "documents_element" U0
                  INNER JOIN "documents_classification" U1 ON (U0."id" = U1."element_id")
                  WHERE U1."id" IS NOT NULL));

WITH element_ids (id) AS
    (DELETE
     FROM documents_elementpath
     WHERE element_id IN
             (SELECT "documents_element"."id"
              FROM "documents_element"
              INNER JOIN "documents_elementpath" ON ("documents_element"."id" = "documents_elementpath"."element_id")
              WHERE "documents_elementpath"."path"[2] IN
                      (SELECT U0."id"
                       FROM "documents_element" U0
                       INNER JOIN "documents_classification" U1 ON (U0."id" = U1."element_id")
                       WHERE U1."id" IS NOT NULL)) RETURNING element_id)
DELETE
FROM documents_element element USING element_ids
WHERE element.id = element_ids.id ;

SELECT "documents_element"."id"
FROM "documents_element"
INNER JOIN "documents_elementpath" ON ("documents_element"."id" = "documents_elementpath"."element_id")
WHERE "documents_elementpath"."path"[2] IN
        (SELECT U0."id"
         FROM "documents_element" U0
         INNER JOIN "documents_classification" U1 ON (U0."id" = U1."element_id")
         WHERE U1."id" IS NOT NULL);

DELETE
FROM "documents_transcriptionentity"
WHERE "documents_transcriptionentity"."id" IN
        (SELECT V0."id"
         FROM "documents_transcriptionentity" V0
         INNER JOIN "documents_transcription" V1 ON (V0."transcription_id" = V1."id")
         WHERE V1."element_id" IN
                 (SELECT U0."id"
                  FROM "documents_element" U0
                  INNER JOIN "documents_classification" U1 ON (U0."id" = U1."element_id")
                  WHERE U1."id" IS NOT NULL));

DELETE
FROM "documents_transcription"
WHERE "documents_transcription"."element_id" IN
        (SELECT U0."id"
         FROM "documents_element" U0
         INNER JOIN "documents_classification" U1 ON (U0."id" = U1."element_id")
         WHERE U1."id" IS NOT NULL);

DELETE
FROM "process_workeractivity"
WHERE "process_workeractivity"."element_id" IN
        (SELECT U0."id"
         FROM "documents_element" U0
         INNER JOIN "documents_classification" U1 ON (U0."id" = U1."element_id")
         WHERE U1."id" IS NOT NULL);

DELETE
FROM "documents_metadata"
WHERE "documents_metadata"."element_id" IN
        (SELECT U0."id"
         FROM "documents_element" U0
         INNER JOIN "documents_classification" U1 ON (U0."id" = U1."element_id")
         WHERE U1."id" IS NOT NULL);

DELETE
FROM "documents_classification"
WHERE "documents_classification"."element_id" IN
        (SELECT U0."id"
         FROM "documents_element" U0
         INNER JOIN "documents_classification" U1 ON (U0."id" = U1."element_id")
         WHERE U1."id" IS NOT NULL);

DELETE
FROM "documents_selection"
WHERE "documents_selection"."element_id" IN
        (SELECT U0."id"
         FROM "documents_element" U0
         INNER JOIN "documents_classification" U1 ON (U0."id" = U1."element_id")
         WHERE U1."id" IS NOT NULL);

DELETE
FROM "process_processelement"
WHERE "process_processelement"."element_id" IN
        (SELECT U0."id"
         FROM "documents_element" U0
         INNER JOIN "documents_classification" U1 ON (U0."id" = U1."element_id")
         WHERE U1."id" IS NOT NULL);

UPDATE "process_process"
SET "element_id" = NULL
WHERE "process_process"."element_id" IN
        (SELECT U0."id"
         FROM "documents_element" U0
         INNER JOIN "documents_classification" U1 ON (U0."id" = U1."element_id")
         WHERE U1."id" IS NOT NULL);

UPDATE "process_process"
SET "train_folder_id" = NULL
WHERE "process_process"."train_folder_id" IN
        (SELECT U0."id"
         FROM "documents_element" U0
         INNER JOIN "documents_classification" U1 ON (U0."id" = U1."element_id")
         WHERE U1."id" IS NOT NULL);

UPDATE "process_process"
SET "validation_folder_id" = NULL
WHERE "process_process"."validation_folder_id" IN
        (SELECT U0."id"
         FROM "documents_element" U0
         INNER JOIN "documents_classification" U1 ON (U0."id" = U1."element_id")
         WHERE U1."id" IS NOT NULL);

UPDATE "process_process"
SET "test_folder_id" = NULL
WHERE "process_process"."test_folder_id" IN
        (SELECT U0."id"
         FROM "documents_element" U0
         INNER JOIN "documents_classification" U1 ON (U0."id" = U1."element_id")
         WHERE U1."id" IS NOT NULL);

WITH element_ids (id) AS
    (DELETE
     FROM documents_elementpath
     WHERE element_id IN
             (SELECT "documents_element"."id"
              FROM "documents_element"
              INNER JOIN "documents_classification" ON ("documents_element"."id" = "documents_classification"."element_id")
              WHERE "documents_classification"."id" IS NOT NULL) RETURNING element_id)
DELETE
FROM documents_element element USING element_ids
WHERE element.id = element_ids.id ;

SELECT "documents_element"."id"
FROM "documents_element"
INNER JOIN "documents_classification" ON ("documents_element"."id" = "documents_classification"."element_id")
WHERE "documents_classification"."id" IS NOT NULL
